<template>
	<view class="container" :style="appThemeStyle">
		<view class="addres-list">
			<view class="address-item">
				<view class="head-info">
					<view class="title">{{ title }}</view>
					<view class="description">{{ description }}</view>
				</view>
				<u-form :label-width="200" :model="form" ref="uForm">
					<u-form-item left-icon="pause-circle" label="放电开关">
						<u-switch slot="right" v-model="form.switchVal1"></u-switch>
					</u-form-item>
					<u-form-item left-icon="lock-open" label="放电开关">
						<u-switch slot="right" v-model="form.switchVal2"></u-switch>
					</u-form-item>
					<u-form-item left-icon="reload" label="更换电池">
						<u-tag text="更换" slot="right"  plain type="error" @click="handleChangeEquipment"></u-tag>
					</u-form-item>
				</u-form>
			</view>
		</view>
		<!-- 换电 -->
		<u-popup v-model="showQRCodeBind" mode="center" border-radius="26" :closeable="true">
			<view class="qrcode-bind">
				<view class="title">请输入更换的新电池编号</view>
				<view class="bind-content">
					<input v-model="bindValue" class="input" @confirm="onSearch" focus="true" placeholder="请输入设备编号"
						type="text"></input>
					<!-- <u-icon @click="scanImage" name="scan"></u-icon> -->
				</view>
				<view class="submit">
					<u-button type="error" @click="doEquipment(true)">确定更换电池</u-button>
				</view>
			</view>
		</u-popup>
	</view>
</template>

<script>
	import * as AddressApi from '@/api/address'
	import Empty from '@/components/empty'
	import * as EquipmentApi from '@/websoft/api/equipment.js'

	export default {
		components: {
			Empty
		},
		data() {
			return {
				//当前页面参数
				options: {},
				equipmentId: {},
				equipment: {},
				form: {
					switchVal1: false,
					switchVal2: false,
				},
				// 正在加载
				isLoading: true,
				// 收货地址列表
				list: [],
				// 默认收货地址
				defaultId: null,
				title: '设备操作',
				showQRCodeBind: false,
				bindValue: '',
				orderId: null,
				description: '用户可控制设备的控制开关'
			}
		},

		/**
		 * 生命周期函数--监听页面加载
		 */
		onLoad(options) {
			// 当前页面参数
			this.options = options
			this.equipmentId = options.equipmentId
		},

		/**
		 * 生命周期函数--监听页面显示
		 */
		onShow() {
			// 获取页面数据
			this.getPageData()
		},

		methods: {

			// 获取页面数据
			getPageData() {
				const app = this
				EquipmentApi.getEquipment(app.equipmentId).then(result => {
					app.equipment = result.data
					app.orderId = result.data.orderId
				})
				// app.isLoading = true
				// Promise.all([app.getDefaultId(), app.getAddressList()])
				// 	.then(() => {
				// 		// 列表排序把默认收货地址放到最前
				// 		app.onReorder()
				// 	})
				// 	.finally(() => app.isLoading = false)
			},

			// 获取收货地址列表
			getAddressList() {
				const app = this
				return new Promise((resolve, reject) => {
					AddressApi.list()
						.then(result => {
							app.list = result.data.list
							resolve(result)
						})
						.catch(reject)
				})
			},
			
			handleChangeEquipment() {
				const app = this
				app.showQRCodeBind = true
			},
			doEquipment(canReset = false) {
				const app = this
				const {
					equipmentId,
					bindValue,
					orderId
				} = this
				EquipmentApi.changeEquipment({
					equipmentCode: bindValue,
					equipmentId,
					orderId
				}).then(result => {
					app.$success(result.message)
					app.showQRCodeBind = false
					app.getPageData()
				}).catch(err => {
					app.$error(err.message)
				})
				console.log("this.bindValue: ", this.bindValue);
			},

			// 获取默认的收货地址
			getDefaultId() {
				return new Promise((resolve, reject) => {
					const app = this
					AddressApi.defaultId()
						.then(result => {
							app.defaultId = result.data.defaultId
							resolve(result)
						})
						.catch(reject)
				})
			},

			// 列表排序把默认收货地址放到最前
			onReorder() {
				const app = this
				app.list.sort(item => {
					return item.address_id == app.defaultId ? -1 : 1
				})
			},

			navTo(url) {
				this.$navTo(url)
			},

			/**
			 * 添加新地址
			 */
			handleCreate() {
				this.$navTo('pages/address/create')
			},

			/**
			 * 编辑地址
			 * @param {int} addressId 收货地址ID
			 */
			handleUpdate(addressId) {
				this.$navTo('pages/address/update', {
					addressId
				})
			},

			/**
			 * 删除收货地址
			 * @param {int} addressId 收货地址ID
			 */
			handleRemove(addressId) {
				const app = this
				uni.showModal({
					title: "提示",
					content: "您确定要删除当前收货地址吗?",
					success({
						confirm
					}) {
						confirm && app.onRemove(addressId)
					}
				});
			},

			/**
			 * 确认删除收货地址
			 * @param {int} addressId 收货地址ID
			 */
			onRemove(addressId) {
				const app = this
				AddressApi.remove(addressId)
					.then(result => {
						app.getPageData()
					})
			},

			/**
			 * 设置为默认地址
			 * @param {Object} addressId
			 */
			handleSetDefault(addressId) {
				const app = this
				AddressApi.setDefault(addressId)
					.then(result => {
						app.defaultId = addressId
						app.options.from === 'checkout' && uni.navigateBack()
					})
			}
		}
	}
</script>

<style lang="scss" scoped>
	.addres-list {
		padding-bottom: calc(constant(safe-area-inset-bottom) + 140rpx);
		padding-bottom: calc(env(safe-area-inset-bottom) + 140rpx);
		padding-top: 20rpx;

		.head-info {
			width: 750rpx;
			margin: auto;
			display: felx;
			flex-direction: column;

			.title {
				font-weight: bold;
				font-size: 34rpx;
			}

			.description {
				padding: 10rpx 0;
				font-size: 30rpx;
				color: #999999;
			}
		}
	}

	// 项目内容
	.address-item {
		margin: 0 auto 20rpx auto;
		padding: 30rpx 40rpx;
		width: 94%;
		box-shadow: 0 1rpx 5rpx 0 rgba(0, 0, 0, 0.05);
		border-radius: 16rpx;
		background: #fff;

		.title {
			display: flex;
			justify-content: space-between;
		}
	}

	.contacts {
		margin-bottom: 16rpx;
		display: flex;
		justify-content: space-between;

		.bms-info {
			display: flex;
			flex-direction: column;

			.item {
				margin-right: 16rpx;
			}

			.name {
				margin-right: 16rpx;
			}
		}

		.bms-image {
			display: flex;
			align-items: center;
			flex-direction: column;
			justify-content: center;
			width: 120rpx;

			.bms-image-box {
				display: flex;
				font-size: 22rpx;
				margin-bottom: 18rpx;
				color: #00af00;

				.bms-image-fbf {
					margin-top: 22rpx;
				}
			}

			.image {
				width: 50rpx;
				height: 60rpx;
			}
		}
	}

	.address {
		font-size: 28rpx;

		.region {
			margin-right: 10rpx;
		}
	}

	.line {
		margin: 20rpx 0;
		border-bottom: 1rpx solid #f3f3f3;
	}

	.line-align {
		width: 6rpx;
		height: 48rpx;
		border-right: 1rpx solid #f3f3f3;
	}

	.item-option {
		display: flex;
		justify-content: space-around;
		align-items: center;
		height: 48rpx;

		// 单选框
		.item-radio {
			font-size: 28rpx;

			.radio {
				vertical-align: middle;
				transform: scale(0.76)
			}

			.text {
				vertical-align: middle;
			}
		}

		// 操作
		.events {
			display: flex;
			align-items: center;
			line-height: 48rpx;

			.event-item {
				font-size: 28rpx;
				margin-right: 26rpx;
				color: #4c4c4c;

				&:last-child {
					margin-right: 0;
				}

				.title {
					margin-left: 8rpx;
				}
			}
		}

	}


	// 底部操作栏
	.footer-fixed {
		position: fixed;
		bottom: var(--window-bottom);
		left: 0;
		right: 0;
		z-index: 11;

		// 设置ios刘海屏底部横线安全区域
		padding-bottom: constant(safe-area-inset-bottom);
		padding-bottom: env(safe-area-inset-bottom);

		.btn-wrapper {
			height: 120rpx;
			padding: 0 40rpx;
		}

		.btn-item {
			flex: 1;
			font-size: 28rpx;
			height: 86rpx;
			color: #fff;
			border-radius: 50rpx;
			display: flex;
			justify-content: center;
			align-items: center;
			box-shadow: 0 1rpx 5rpx 0 rgba(0, 0, 0, 0.05);
		}

		.btn-item-main {
			background: linear-gradient(to right, $main-bg, $main-bg2);
		}

	}
	// 弹出层 - 绑定设备码
	.qrcode-bind{
		  width: 550rpx;
		  height: 300rpx;
		  padding: 36rpx 30rpx;
		  
		  .title {
		    font-size: 30rpx;
		    margin-bottom: 26rpx;
		    font-weight: bold;
		    text-align: center;
		  }
		  
		  .bind-content {
		    padding: 0 10rpx;
			border: 1rpx solid #eee;
			font-size: 24rpx;
			display: flex;
		  
		    .image {
		      display: block;
		      width: 510rpx;
		      height: 510rpx;
		    }
		  
		  }
		  .submit{
			  margin-top: 30rpx;
		  }
	}
</style>
